<template>
<v-dialog :value="value" @input="$emit('input')" scrollable max-width="500px" persistent>
  <v-card>
  <v-card-text class="pop"> 
    <st-title text="Datos del alumno"/>
      <v-form
        ref="form"
        v-model="valid"
      >
      <div class="fields">
        <v-text-field
          v-for="(field, index) in fields"
          v-model="field.value"
          :counter="field.counter"
          :rules="field.rules"
          :label="field.label"
          :type="field.type"
          :key="index"
          required
        />
        <v-select
          v-model="especialidad.id"
          :items="items"
          label="Especialidad"
          item-text="nombre"
          item-value="idUnidad"
          required
        />
      </div>
      <div class="content-footer">
        <st-secondary-btn 
          nombre="Cancelar" 
          @click="$emit('input')"
        />
        <st-primary-btn
          nombre = "Actualizar alumno"
          @click="register"
          :disable="!valid"
          :loading="loading"
        />
      </div>
      </v-form>
    </v-card-text>
  </v-card>
</v-dialog>
</template>

<script>
import user from '@/assets/js/user-fields'


export default {
  props:{
    data: Object,
    value: Boolean
  },
  data(){
    return{
      valid: false,
      items: [],
      loading: false,
      fields: {},
      especialidad:{
                id: null,
                nombre: "",
                rules:[
                    v => !!v || 'La especialidad es requerida',
                ]
      }
    }
  },
  mounted(){
    this.fields = Object.assign({}, user) //copy object
    let fields = this.data.fields
    this.especialidad.id=this.data.ids.idUnidad
    this.especialidad.nombre=this.data.nombreUnidad
    for (let prop in fields){
      this.fields[prop].value = fields[prop].value || ''
    }
    this.getUnits()
  },
  methods:{
    async getUnits(){
            try{
                // let { data : { data } } = await this.$api.getUnits()
                let { data : { data } } = await this.$api.getUnitsByUnitId(this.$store.state.role.idUnit)

                // nos estamos guiando de la api
                // http://127.0.0.1:5000/api/unidades/73d40eb8-cbb8-4650-8e69-01c30c083b32
                if (data.programas !== null)
                  data.programas.forEach(programa => this.items.push(programa));
                else
                  this.items.push(data.unidad);

            } catch (e){
                this.$store.commit('setError', e)
            }
    },
    async register(){
      let field = this.fields
      let ids = this.data.ids
      let data = {
        'alumno':{
          'correo':field.correo.value,
          'codigo':field.codigo.value,
          'nombres': field.nombres.value,
          'apellidoPaterno': field.apellidoPat.value,
          'apellidoMaterno': field.apellidoMat.value,
          'telefono': field.telefono.value,
          'idUnidad': this.especialidad.id
        }
      }
      this.loading = true
      try{
        let response = await this.$api.updateUser(ids.idStudent,data)
        this.$emit('refresh',{ response: response})
      } catch(e) {
        this.$store.commit('setError', e)
      }
      this.loading = false
    }
  }
}
</script>

<style scoped lang="scss"> 
/* scope for encapsulate css */
</style>

